package com.izouma.dingdong.web.backstage;

import com.izouma.dingdong.web.BaseController;
import com.izouma.dingdong.domain.backstage.ChatWords;
import com.izouma.dingdong.service.backstage.ChatWordsService;
import com.izouma.dingdong.dto.PageQuery;
import com.izouma.dingdong.exception.BusinessException;
import com.izouma.dingdong.repo.backstage.ChatWordsRepo;
import com.izouma.dingdong.utils.ObjUtils;
import com.izouma.dingdong.utils.excel.ExcelUtils;

import lombok.AllArgsConstructor;
import org.springframework.data.domain.Page;
import org.springframework.security.access.prepost.PreAuthorize;
import org.springframework.web.bind.annotation.*;

import javax.servlet.http.HttpServletResponse;
import java.io.IOException;
import java.util.List;

@RestController
@RequestMapping("/chatWords")
@AllArgsConstructor
public class ChatWordsController extends BaseController {
    private ChatWordsService chatWordsService;
    private ChatWordsRepo chatWordsRepo;

    //@PreAuthorize("hasRole('ADMIN')")
    @PostMapping("/save")
    public ChatWords save(@RequestBody ChatWords record) {
        if (record.getId() != null) {
            ChatWords orig = chatWordsRepo.findById(record.getId()).orElseThrow(new BusinessException("无记录"));
            ObjUtils.merge(orig, record);
            return chatWordsRepo.save(orig);
        }
        return chatWordsRepo.save(record);
    }


    //@PreAuthorize("hasRole('ADMIN')")
    @GetMapping("/all")
    public Page<ChatWords> all(PageQuery pageQuery) {
        return chatWordsRepo.findAll(toSpecification(pageQuery,ChatWords.class), toPageRequest(pageQuery));
    }

    @GetMapping("/get/{id}")
    public ChatWords get(@PathVariable Long id) {
        return chatWordsRepo.findById(id).orElseThrow(new BusinessException("无记录"));
    }

    @PostMapping("/del/{id}")
    public void del(@PathVariable Long id) {
        chatWordsRepo.deleteById(id);
    }

    @GetMapping("/excel")
    @ResponseBody
    public void excel(HttpServletResponse response, PageQuery pageQuery) throws IOException {
        List<ChatWords> data = all(pageQuery).getContent();
        ExcelUtils.export(response, data);
    }
}

